"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const cors_1 = __importDefault(require("cors"));
const express_2 = require("express");
require("express-async-errors");
const express_rate_limit_1 = __importDefault(require("express-rate-limit"));
const user_1 = require("./routes/user");
require("./utils/db");
const finance_1 = require("./routes/finance");
const product_1 = require("./routes/product");
const admin_1 = require("./routes/admin");
const finance_product_1 = require("./routes/finance-product");
const config_1 = require("./config/config");
const app = (0, express_1.default)();
const limiter = (0, express_rate_limit_1.default)({
    windowMs: 15 * 60 * 1000,
    max: 100,
    standardHeaders: true,
    legacyHeaders: false,
});
app.use(limiter);
/* app.use(cors({
  origin: '*',
})); */
app.use((0, cors_1.default)({
    origin: config_1.config.corsOrigin,
}));
app.use((0, express_2.json)());
app.use('/api/user', user_1.userRouter);
app.use('/api/finance', finance_1.financeRouter);
app.use('/api/product', product_1.productRouter);
app.use('/api/finance-product', finance_product_1.financeProductRouter);
app.use('/api/admin', admin_1.adminRouter);
app.listen(3001, '0.0.0.0', () => {
    console.log('server running on http://localhost:3001');
});
//# sourceMappingURL=index.js.map