"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Admin = void 0;
const uuid_1 = require("uuid");
const db_1 = require("../utils/db");
class Admin {
    static get(name) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute('SELECT `name`, `password` FROM `admin` WHERE `name`=:name', {
                name,
            });
            return result.length === 0 ? null : result[0];
        });
    }
    static getArticles() {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute('SELECT `id`, `title`, `description`, `date` FROM `article` ORDER BY `date` ASC');
            return result.length === 0 ? [] : result;
        });
    }
    static addArticle(title, description, date) {
        return __awaiter(this, void 0, void 0, function* () {
            const id = (0, uuid_1.v4)();
            yield db_1.pool.execute('INSERT INTO `article` (id, title, description, date) VALUES (:id, :title, :description, :date)', {
                id,
                title,
                description,
                date,
            });
            return id;
        });
    }
    static deleteArticle(id) {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute('DELETE FROM `article` WHERE `id`=:id', {
                id,
            });
            return id;
        });
    }
}
exports.Admin = Admin;
//# sourceMappingURL=admin.js.map