"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Finance = void 0;
const db_1 = require("../utils/db");
const errors_1 = require("../utils/errors");
const uuid_1 = require("uuid");
;
class Finance {
    constructor(obj) {
        if (!obj.salary || obj.salary > 9999999) {
            throw new errors_1.ValidationError('Nie prawidłowa wartość pola "wynagrodzenie"');
        }
        ;
        if (!obj.savings || obj.savings > 9999999) {
            throw new errors_1.ValidationError('Nie prawidłowa wartość pola "oszczędnośći"');
        }
        ;
        if (!obj.monthlyExpanse || obj.monthlyExpanse > 9999999) {
            throw new errors_1.ValidationError('Nie prawidłowa wartość pola "miesięczne wydatki"');
        }
        ;
        this.id = obj.id;
        this.salary = obj.salary;
        this.savings = obj.savings;
        this.monthlyExpanse = obj.monthlyExpanse;
    }
    ;
    static getOne(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute('SELECT `salary`, `savings`, `monthlyExpanse` FROM `finance` WHERE `id`=:id', {
                id,
            });
            return result.length === 0 ? null : new Finance(result[0]);
        });
    }
    ;
    add() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.id) {
                this.id = (0, uuid_1.v4)();
            }
            ;
            yield db_1.pool.execute('INSERT INTO `finance` (`id`, `salary`, `savings`, `monthlyExpanse`) VALUES (:id, :salary, :savings, :monthlyExpanse)', {
                id: this.id,
                salary: this.salary,
                savings: this.savings,
                monthlyExpanse: this.monthlyExpanse,
            });
            return this.id;
        });
    }
    ;
    update(id) {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute('UPDATE `finance` SET `salary`=:salary, `savings`=:savings, `monthlyExpanse`=:monthlyExpanse WHERE `id`=:id', {
                id,
                salary: this.salary,
                savings: this.savings,
                monthlyExpanse: this.monthlyExpanse,
            });
            return true;
        });
    }
    ;
    static delete(id) {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute('DELETE FROM `finance` WHERE `id`=:id', {
                id,
            });
            return true;
        });
    }
    ;
}
exports.Finance = Finance;
;
//# sourceMappingURL=finance.js.map