"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const uuid_1 = require("uuid");
const db_1 = require("../utils/db");
const errors_1 = require("../utils/errors");
class User {
    constructor(obj) {
        if (!obj.name || obj.name.length > 100) {
            console.log(obj.name);
            throw new errors_1.ValidationError('Nie prawidłowa wartość pola "imię"');
        }
        ;
        if (!obj.surname || obj.surname.length > 100) {
            throw new errors_1.ValidationError('Nie prawidłowa wartość pola "nazwisko"');
        }
        ;
        if (!obj.job || obj.job.length > 100) {
            throw new errors_1.ValidationError('Nie prawidłowa wartość pola "stanowisko"');
        }
        ;
        this.id = obj.id;
        this.name = obj.name;
        this.surname = obj.surname;
        this.job = obj.job;
        this.financeId = obj.financeId;
    }
    ;
    static getAll() {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute('SELECT * FROM `user` ORDER BY `name` ASC');
            return result.length === 0 ? [] : result.map((obj) => new User(obj));
        });
    }
    ;
    static getOne(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute('SELECT * FROM `user` WHERE `id`=:id', {
                id,
            });
            return result.length === 0 ? null : new User(result[0]);
        });
    }
    ;
    add() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.id) {
                this.id = (0, uuid_1.v4)();
            }
            ;
            yield db_1.pool.execute('INSERT INTO `user` (`id`, `name`, `surname`, `job`) VALUES (:id, :name, :surname, :job)', {
                id: this.id,
                name: this.name,
                surname: this.surname,
                job: this.job,
            });
            return this.id;
        });
    }
    ;
    deleteUser() {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute('DELETE FROM `user` WHERE `id`=:id', {
                id: this.id,
            });
            return true;
        });
    }
    static addFinance(userId, financeId) {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute('UPDATE `user` SET `financeId`=:financeId WHERE `id`=:userId', {
                userId,
                financeId,
            });
            return true;
        });
    }
    ;
}
exports.User = User;
;
//# sourceMappingURL=user.js.map