"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.financeProductRouter = void 0;
const express = __importStar(require("express"));
const financeProduct_1 = require("../libs/financeProduct");
const product_1 = require("../libs/product");
exports.financeProductRouter = express.Router()
    .get('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const financeProduct = yield financeProduct_1.FinanceProduct.getOne(req.params.id);
    res.json(financeProduct);
}))
    .get('/user/:financeId', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const products = yield financeProduct_1.FinanceProduct.getAllOfUser(req.params.financeId);
    res.json(products ? products : null);
}))
    .get('/used/:productId', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const users = yield financeProduct_1.FinanceProduct.checkIfUsed(req.params.productId);
    res.json(users);
}))
    .get('/forecast/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const financeAndProductsList = yield financeProduct_1.FinanceProduct.getAllOfUser(req.params.id);
    const products = yield product_1.Product.getAll();
    const userProductArray = [];
    if (financeAndProductsList) {
        /* const userProduct =  */ financeAndProductsList.forEach(financeAndProduct => {
            const currentProduct = products.filter(product => product.id === financeAndProduct.productId);
            userProductArray.push({
                name: currentProduct[0].name,
                startDate: financeAndProduct.startDate,
                duration: Number(currentProduct[0].durationInDays),
                annualInterestRate: Number(currentProduct[0].annualInterestRate),
                resources: financeAndProduct.resources,
            });
        });
    }
    res.json(userProductArray);
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const product = new financeProduct_1.FinanceProduct(req.body);
    const id = yield product.add();
    res.json(product ? product : null);
}))
    .delete('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const financeProduct = yield financeProduct_1.FinanceProduct.getOne(req.params.id);
    const id = financeProduct.delete();
    res.json(id);
}));
//# sourceMappingURL=finance-product.js.map